#ifndef _DEFERRED_C_
#define _DEFERRED_C_

#ifndef PP_Helper
#define PP_Helper
#endif

#define DL_MAX_LIGHTS 25

float DL_LightPos[DL_MAX_LIGHTS][4];
float DL_LightColor[DL_MAX_LIGHTS][4];

MATERIAL* matShading =
{
	effect = "Shading.fx";
}

void DL_setLight(int num, VECTOR *pos, VECTOR *color, var range)
{
	DL_LightPos[num][0] = (float)pos.x;
	DL_LightPos[num][1] = (float)pos.z;
	DL_LightPos[num][2] = (float)pos.y;
	DL_LightPos[num][3] = (float)range;
	
	DL_LightColor[num][0] = (float)color.x/(float)255;
	DL_LightColor[num][1] = (float)color.y/(float)255;
	DL_LightColor[num][2] = (float)color.z/(float)255;
	DL_LightColor[num][3] = (float)1.0;
}

void DL_SetRenderTargets()
{
	camera.bmap = bmap_createblack(screen_size.x, screen_size.y, 32);
	camera.target1 = bmap_createblack(screen_size.x, screen_size.y, 14444);
	camera.target2 = bmap_createblack(screen_size.x, screen_size.y, 32);
//	camera.target3 = bmap_createblack(screen_size.x, screen_size.y, 14444);
	
	matShading.skin1 = camera.bmap;		//Color+Spec
	matShading.skin2 = camera.target1;	//WorldPos+Pow
	matShading.skin3 = camera.target2;	//Normal+Illumination
//	matShading.skin4 = camera.target3;
}

void DL_SetPipeline()
{
	int i;
	for(i = 0; i < DL_MAX_LIGHTS; i++)
	{
		DL_setLight(i, vector(0, 0, 0), vector(0, 0, 0), 0);
	}
	
	PP_Add(matShading, camera, NULL);
}

#endif
